const Discord = require('discord.js');

module.exports = {
    name: "ban",
    description : "Ban a member",
    permission: Discord.PermissionFlagsBits.BanMembers,
    dm: false,
    options: [
        {
            type: "user",
            name: "member",
            description: "The user to ban",
            required: true
        }, {
            type: "string",
            name: "reason",
            description: "The reason for the ban",
            required: false
        }
    ],
    
    async run(bot, message, args) {
        
        try {
            const user = await bot.users.fetch(args._hoistedOptions[0].value)
            if(!user) return message.reply("No user to ban !")
            const member = message.guild.members.cache.get(user.id)

            let reason = args.getString("reason")
            if(!reason) reason = "No reason provided !";

            if(message.user.id === user.id) return message.reply("Don't try to ban yourself !")
            if((await message.guild.fetchOwner()).id === user.id) return message.reply("Don't try to ban the owner !")
            if(member && !member.bannable) return message.reply("I can't ban this user !")
            if(member && message.member.roles.highest.comparePositionTo(member.roles.highest) <=0) return message.reply("You can't ban this user !")
            if((await message.guild.bans.fetch()).get(user.id)) return message.reply("This user is already banned !")

            try {await user.send(`You had banned from the server ${message.guild.name} by ${message.user.tag} for the reason : \`${reason}\` !`)} catch (err) {}

            await message.guild.bans.create(user.id, {reason: reason})

            await message.reply(`You have ban ${message.user.tag} from the server ${message.guild.name} for the reason : \`${reason}\``)


        } catch (err) {
            console.log(err)
            return message.reply("No user to ban !")
        }
    }
}