const Discord = require('discord.js');

module.exports = {
    name: "kick",
    description : "Kick a member",
    permission: Discord.PermissionFlagsBits.KickMembers,
    dm: false,
    options: [
        {
            type: "user",
            name: "member",
            description: "The user to kick",
            required: true
        }, {
            type: "string",
            name: "reason",
            description: "The reason for the kick",
            required: false
        }
    ],
    
    async run(bot, message, args) {

        const user = args.getUser("member")
        if(!user) return message.reply("No user to kick !")
        const member = message.guild.members.cache.get(user.id)
        if(!member) return message.reply("No user to kick !")

        let reason = args.getString("reason")
        if(!reason) reason = "No reason provided !";

        if(message.user.id === user.id) return message.reply("Don't try to kick yourself !")
        if((await message.guild.fetchOwner()).id === user.id) return message.reply("Don't try to kick the owner !")
        if(member && !member.kickable) return message.reply("I can't kick this user !")
        if(member && message.member.roles.highest.comparePositionTo(member.roles.highest) <=0) return message.reply("You can't kick this user !")

        try {await user.send(`You had kicked from the server ${message.guild.name} by ${message.user.tag} for the reason : \`${reason}\` !`)} catch (err) {}

        await message.kick(reason)

        await message.reply(`You have kick ${message.user.tag} from the server ${message.guild.name} for the reason : \`${reason}\``)

    }
}