const Discord = require('discord.js');
const ms = require('ms');

module.exports = {
    name: "mute",
    description : "Mute a member",
    permission: Discord.PermissionFlagsBits.ModerateMembers,
    dm: false,
    options: [
        {
            type: "user",
            name: "member",
            description: "The user to mute",
            required: true
        }, {
            type: "string",
            name: "duration",
            description: "The duration for the mute",
            required: true
        }, {
            type: "string",
            name: "reason",
            description: "The reason for the mute",
            required: false
        }
    ],
    
    async run(bot, message, args) {
        let user = args.getUser("membre")
        if(!user) return message.reply("No user to mute !")
        let member = message.guild.members.cache.get(user.id)
        if(!member) return message.reply("No user to mute !")

        let time = args.getString("duration")
        if(!time) return message.reply("No duration provided !")
        if(isNaN(ms(time))) return message.reply("Duration isn't formatted correctly !")
        if(ms(time) > 86400000) return message.reply("Duration must be under 28 days !")

        let reason = args.getString("reason")
        if(!reason) reason = "No reason provided !";

        if(message.user.id === user.id) return message.reply("Don't try to mute yourself !")
        if((await message.guild.fetchOwner()).id === user.id) return message.reply("Ne mute pas le propriétaire du serveur !")
        if(member.moderatable) return message.reply("I can't mute this user !")
        if(member && message.member.roles.highest.comparePositionTo(member.roles.highest) <=0) return message.reply("You can't mute this user !")
        if(member.isCommunicationDisabled()) return message.reply("This member is already muted !")

        try {await user.send(`You had muted from the server ${message.guild.name} by ${message.user.tag} during ${time} for the reason : \`${reason}\` !`)} catch (err) {}

        await message.timeout(ms(time), reason)

        await message.reply(`You have mute ${message.user.tag} from the server ${message.guild.name} during ${time} for the reason : \`${reason}\``)
    }
}